@0xbf017710be5a54ff;

using Rust = import "programming_language/rust.capnp";
$Rust.parentModule("schema");

using CSharp = import "programming_language/csharp.capnp";
$CSharp.namespace("FabAccessAPI.Schema");

using AuthenticationSystem = import "authenticationsystem.capnp".AuthenticationSystem;
using MachineSystem = import "machinesystem.capnp".MachineSystem;
using UserSystem = import "usersystem.capnp".UserSystem;
using PermissionSystem = import "permissionsystem.capnp".PermissionSystem;

const API_VERSION_MAJOR :Int32  = 0;
const API_VERSION_MINOR :Int32  = 3;
const API_VERSION_PATCH :Int32  = 0;

struct Version
{
    major @0 :Int32;
    minor @1 :Int32;
    patch @2 :Int32;
}

interface Bootstrap 
{
    getAPIVersion @0 () -> ( version : Version );

    getServerRelease @1 () -> ( name :Text, release :Text );
    # Returns the server implementation name and version/build number
    # Designed only for human-facing debugging output so should be informative over machine-readable
    # Example: ( name = "bffhd", release = "0.3.1-f397e1e [rustc 1.57.0 (f1edd0429 2021-11-29)]")

    authenticationSystem @2 () -> ( authenticationSystem : AuthenticationSystem );

    machineSystem @3 () -> ( machineSystem : MachineSystem );
    
    userSystem @4 () -> ( userSystem : UserSystem );

    permissionSystem @5 () -> ( permissionSystem : PermissionSystem );
}
